package com.sleepycat.je.log;

import java.io.IOException;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import com.sleepycat.je.mock.DatabaseException;
import com.sleepycat.je.mock.EnvironmentImpl;
import com.sleepycat.je.checksum.*;

public class FileReaderTest {

	private EnvironmentImpl env;
	private FileReader reader;

//	@Before
	public void setUp() throws Exception {
		env=new EnvironmentImpl();
		reader=new FileReader(env, 10, true, 0,null, 0,0);
	}

//	@Test
	public void testFileReader() {
		Assert.assertTrue(reader.doValidateChecksum);
		Assert.assertNotNull(reader.cksumValidator);
	}

//	@Test
	public void testSetAlwaysValidateChecksum() {
//		fail("Not yet implemented"); // TODO
	}

//	@Test
	public void testReadNextEntry() throws DatabaseException, IOException {
		Assert.assertTrue(reader.readNextEntry());
	}

}
