class Rectangle extends Shape exhibits Update, UpdateColor, ToString {
  pointcut Update : super;
  pointcut UpdateColor : execution(void fill(Color)) && this(shape) && args(color);
  pointcut ToString : call(String toString()) && this(caller) && target(callee);

  Color color;

  private Point p1, p2;
  public Rectangle(Point pa, Point pb) { p1 = pa; p2 = pb; }
  public Point getP1() { return p1; }
  public Point getP2() { return p2; }
  public void moveBy(int dx, int dy) {
    p1.x += dx; p1.y += dy; 
    p2.x += dx; p2.y += dy;
  } 
  public void fill(Color c) {
  
  }
  public String toString() {
	return "Rectangle(" + p1.toString() + "," + p2.toString() + ")";
  }
} 