package com.sleepycat.je.mock;

import java.nio.ByteBuffer;

public class LogUtils {

	public static long getUnsignedInt(ByteBuffer buf) {
		long ret = (buf.get() & 0xFFL) << 0;
		ret += (buf.get() & 0xFFL) << 8;
		ret += (buf.get() & 0xFFL) << 16;
		ret += (buf.get() & 0xFFL) << 24;
		return ret;
	}

	/**
	 * Read a int from the log.
	 */
	public static int readInt(ByteBuffer logBuf) {
		int ret = (logBuf.get() & 0xFF) << 0;
		ret += (logBuf.get() & 0xFF) << 8;
		ret += (logBuf.get() & 0xFF) << 16;
		ret += (logBuf.get() & 0xFF) << 24;
		return ret;
	}

}
