
public class IN exhibits OverheadSizeChanged {
	
	pointcut OverheadSizeChanged : this(in) && (
		execution(void IN.setLsn(int,long)) ||
		call(void IN.shiftEntriesRight(int)));


	public boolean deleteEntry(final int index, boolean maybeValidate) {
		if (nEntries == 0 || index >= nEntries)
			return false;

		exhibit new OverheadSizeChanged(this) {
			for (int i = index; i < nEntries - 1; i++) 
				setEntryInternal(i + 1, i);
			clearEntry(nEntries - 1);
		};
		nEntries--;
		setDirty(true);
		return true;
	}

	private void setProhibitNextDelta() {
		System.out.println("setProhibitNextDelta");
	}

	private void setDirty(boolean b) {
		System.out.println("setDirty");
	}

	private void clearEntry(int i) {
		System.out.println("clearEntry");
	}

	private void setEntryInternal(int i, int i2) {
		System.out.println("setEntryInternal");
	}

	void setLsn(int a, long b) {
		System.out.println("setLsn");
	}

	void shiftEntriesRight(int a) { 
		System.out.println("shiftEntriesRight");
	}

	public int computeLsnOverhead() {
		System.out.println("computeLsnOverhead");
		return 0;
	}

	public void changeMemorySize(int i) {
		System.out.println("changeMemorySize");
	}
	int nEntries = 3;

}
