joinpointtype A allows before, after {int i;}
joinpointtype B extends A {}
joinpointtype C extends B {}
joinpointtype D extends C {}

aspect X advises A, C{
	before(A a) {
		System.out.println("\t**[before] "+thisJoinPoint+" for A with jpt : "+a.getClass().getName());
	}
	
	before(C c) {
		System.out.println("\t**[before] "+thisJoinPoint+" for C with jpt : "+c.getClass().getName());
	}
	
//	after(C c) {
//		System.out.println("\t**[after] "+thisJoinPoint+" for C with jpt : "+c.getClass().getName());
//	}
}

class O exhibits A, /*B,*/ C, D {
	pointcut A : (execution(void fooA(..)) || execution(void fooC(..))) && args(i);
//	pointcut B : execution(void fooB(..)) && args(i);
	pointcut C : execution(void fooC(..)) && args(i);
	pointcut D : execution(void fooD(..)) && args(i);

	public void fooA(int a) {System.out.println("fooA("+a+")");}
	public void fooB(int b) {System.out.println("fooB("+b+")");}
	public void fooC(int c) {System.out.println("fooC("+c+")");}
	public void fooD(int d) {System.out.println("fooD("+d+")");}
}

class Test {
	public static void main(String[] args) {
		new O().fooA(5);
		new O().fooB(6);
		new O().fooC(7);
		new O().fooD(8);
	}
}